package com.hungraim.ltc.governance.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hungraim.ltc.governance.dao.SuperviseOrganEmpMapper;
import com.hungraim.ltc.governance.dao.SuperviseOrganMapper;
import com.hungraim.ltc.governance.service.SuperviseOrganEmpService;
import com.hungraim.ltc.pojo.entity.serviceManage.ChSuperviseOrgan;
import com.hungraim.ltc.pojo.entity.serviceManage.ChSuperviseOrganEmp;
import com.hungraim.ltc.pojo.vo.governance.SuperviseOrganEmpVO;
import com.hungraim.ltc.pojo.vo.governance.SuperviseOrganVO;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

/**
 * 监管机构人员信息管理ServiceImpl
 */
@Service
@Slf4j
@AllArgsConstructor
public class SuperviseOrganServiceImpl implements SuperviseOrganEmpService {
    private final SuperviseOrganEmpMapper superviseOrganEmpMapper;
    private final SuperviseOrganMapper superviseOrganMapper;

    @Override
    public Page<SuperviseOrganEmpVO> superviseOrganEmpList(Page<SuperviseOrganEmpVO> page, String organId, String organName, String superviseType, String superviseName, String superviseTel, String status) {
        List<String> organIds = null;
        if (StrUtil.isNotBlank(organId)) {
            organIds = Arrays.asList(organId.split(","));
        }
        return superviseOrganEmpMapper.superviseOrganEmpList(page, organIds, organName, superviseType, superviseName, superviseTel, status);
    }

    @Override
    public void updateEmpStatus(String empId, Short isLock) {
        ChSuperviseOrganEmp chSuperviseOrganEmp = superviseOrganEmpMapper.selectById(empId);
        chSuperviseOrganEmp.setIsLock(isLock);
        superviseOrganEmpMapper.updateById(chSuperviseOrganEmp);
    }

    @Override
    public void insertOrUpdateEmpInfo(Long empId, Long spvOrganId, String spvEmpName, String certifType, String certifNum, String gender, Short age, String superviseTel, Short status) {
        if (empId != null) {
            //更新
            ChSuperviseOrganEmp chSuperviseOrganEmp = superviseOrganEmpMapper.selectById(empId);
            chSuperviseOrganEmp.setSpvOrganId(spvOrganId);
            chSuperviseOrganEmp.setSpvEmpName(spvEmpName);
            chSuperviseOrganEmp.setCertifType(certifType);
            chSuperviseOrganEmp.setCertifNum(certifNum);
            chSuperviseOrganEmp.setGender(gender);
            chSuperviseOrganEmp.setAge(age);
            chSuperviseOrganEmp.setMobilePhone(superviseTel);
            chSuperviseOrganEmp.setIsLock(status);
            superviseOrganEmpMapper.updateById(chSuperviseOrganEmp);
        } else {
            //新增
            ChSuperviseOrganEmp chSuperviseOrganEmp = new ChSuperviseOrganEmp();
            chSuperviseOrganEmp.setEffTime(new Date());
            chSuperviseOrganEmp.setSpvOrganId(spvOrganId);
            chSuperviseOrganEmp.setSpvEmpName(spvEmpName);
            chSuperviseOrganEmp.setCertifType(certifType);
            chSuperviseOrganEmp.setCertifNum(certifNum);
            chSuperviseOrganEmp.setGender(gender);
            chSuperviseOrganEmp.setAge(age);
            chSuperviseOrganEmp.setMobilePhone(superviseTel);
            chSuperviseOrganEmp.setIsLock(status);
            superviseOrganEmpMapper.insert(chSuperviseOrganEmp);
        }
    }

    @Override
    public List<SuperviseOrganVO> superviseOrganList(String organId, String spvOrganName) {
        List<String> organIds = null;
        if (StrUtil.isNotBlank(organId)) {
            organIds = Arrays.asList(organId.split(","));
        }
        return superviseOrganMapper.superviseOrganList(organIds, spvOrganName);
    }

    @Override
    public void updateSpvStatus(String spvOrganId, Short isLock) {
        ChSuperviseOrgan chSuperviseOrgan = superviseOrganMapper.selectById(spvOrganId);
        chSuperviseOrgan.setIsLock(isLock);
        superviseOrganMapper.updateById(chSuperviseOrgan);
    }

    @Override
    public void insertOrUpdateSpvInfo(ChSuperviseOrgan spvOrgan) {
        if (spvOrgan.getSpvOrganId() != null) {
            //更新
            superviseOrganMapper.updateById(spvOrgan);
        } else {
            //新增
            spvOrgan.setEffTime(new Date());
            superviseOrganMapper.insert(spvOrgan);
        }
    }
}
